﻿#include "hmiworks.h"
BYTE ladder_main(BYTE);

int g_hmi_CurrentFrame = 0;
static int s_hmi_tcp_inited = 0;

static const char *g_FrameNames[] = 
{
  "Frame1",
};

const int g_FrameCount = (sizeof(g_FrameNames)/sizeof(char *));

#define MAGIC_NUM_TO_CON		472882027

HANDLE TCPIP_1=-1;
unsigned long TCPIP_1_RI = 0;
tModbusTCPDevice ICPDAS_Master={-1};

void hmi_CheckModbus()
{
  MODBUS_CHECK(ICPDAS_Master);
}

void _tpd_tcp_initial()
{
  if ( !lwIPLocalIPAddrGet() ) return;

  MODBUS_REGISTER_TCP(TCPIP_1, TCP_IPADDR(10,0,8,130), 502);
  MODBUS_REGISTER_BY_HANDLE(ICPDAS_Master, TCPIP_1, 1);
   MODBUS_WAIT(ICPDAS_Master);

  TCPIP_1_RI = 0;

  s_hmi_tcp_inited = 1;
}

volatile unsigned long g_TimerTicksCount = 0;
unsigned long g_ulTickTmrEvtTrig = 0;

static volatile bool ICPDAS_Master_flag = false;

void hmi_TimerTrigger()
{
  g_TimerTicksCount++;
  
  if ((g_TimerTicksCount%(200/10)) == 0)
  ICPDAS_Master_flag = true;
  
  if ( g_TimerTicksCount%(100/10) == 0)
  { g_ulTickTmrEvtTrig = g_TimerTicksCount;
    HMI_REQUEST_LADDER_PROCESS();}
  
  if ( s_hmi_tcp_inited ) {
     if ((g_TimerTicksCount%50) == 0) hmi_CheckModbus();
  } else if ( g_TimerTicksCount > 80 )
     _tpd_tcp_initial();
  
  switch(g_hmi_CurrentFrame) {
    case 1: {
     TimerUpdate(&Timer13, 10);
    break;
    }
  }
}

void hmi_FreeCurrentFrame()
{
  switch (g_hmi_CurrentFrame)
  {
	case 1: hmi_FreeFrameWidgets1(); break;
  }
}

void hmi_GetActiveFrame(char* str, unsigned int len)
{
  int FNLen = strlen(g_FrameNames[g_hmi_CurrentFrame-1]) +1;
  if(len >= FNLen)
    memcpy(str, g_FrameNames[g_hmi_CurrentFrame-1], FNLen);
}

const char* hmi_GetCurrentFrameName()
{ return g_FrameNames[g_hmi_CurrentFrame-1];}

extern int hmi_frame_number_to_go;
void hmi_GotoFrameAction(int nFrame)
{
  switch(nFrame)
  {
	case 1: hmi_Frame1(); break;
  }

  WidgetMessageQueueClear();
  HMI_REDRAW();
}

void hmi_GotoFrame(int nFrame)
{
  hmi_frame_number_to_go = nFrame;
}

int hmi_IndexOfFrame(const char *frame_name)
{
  for (int i=0; i<g_FrameCount; i++)
    if (strcmp(frame_name, g_FrameNames[i]) == 0) return i+1;
  return 0;
}

void hmi_GotoFrameByName(const char *frame_name)
{
  hmi_frame_number_to_go = hmi_IndexOfFrame(frame_name);
}

long hmi_Ladder_Process(tWidget *pWidget, unsigned long ulMessage,
                     unsigned long ulParam1, unsigned long ulParam2)

{
  ladder_main(1);
  passDataThruBindingOnChange();
  default_output(1);
  return 1;
}

BYTE polling_ICPDAS_Master(BYTE en)
{
  if ( ! ICPDAS_Master_ENABLE_DEVICE ) return 0;
  if (MODBUS_CONNECTED(ICPDAS_Master)) {
int   gWriteCount=0;
WORD v_ao[16] = {0};
BEGIN_FUNCTION_BLOCK();

memset(v_ao, 0, sizeof(v_ao));
if (ICPDAS_Master_ENABLE_AO && ICPDAS_Master_W_ACTION)
{
   int iWrite = 0;

   if( VAR_FLAG_IS_WRITE(ICPDAS_Master_AO0) ) iWrite++;
   v_ao[0] = VAR_VALUE(ICPDAS_Master_AO0);
   if( VAR_FLAG_IS_WRITE(ICPDAS_Master_AO1) ) iWrite++;
   v_ao[1] = VAR_VALUE(ICPDAS_Master_AO1);
   if( VAR_FLAG_IS_WRITE(ICPDAS_Master_AO2) ) iWrite++;
   v_ao[2] = VAR_VALUE(ICPDAS_Master_AO2);
   if( VAR_FLAG_IS_WRITE(ICPDAS_Master_AO3) ) iWrite++;
   v_ao[3] = VAR_VALUE(ICPDAS_Master_AO3);
   if( VAR_FLAG_IS_WRITE(ICPDAS_Master_AO4) ) iWrite++;
   v_ao[4] = VAR_VALUE(ICPDAS_Master_AO4);
   if( VAR_FLAG_IS_WRITE(ICPDAS_Master_AO5) ) iWrite++;
   v_ao[5] = VAR_VALUE(ICPDAS_Master_AO5);
   if( VAR_FLAG_IS_WRITE(ICPDAS_Master_AO6) ) iWrite++;
   v_ao[6] = VAR_VALUE(ICPDAS_Master_AO6);
   if( VAR_FLAG_IS_WRITE(ICPDAS_Master_AO7) ) iWrite++;
   v_ao[7] = VAR_VALUE(ICPDAS_Master_AO7);
   if( VAR_FLAG_IS_WRITE(ICPDAS_Master_AO8) ) iWrite++;
   v_ao[8] = VAR_VALUE(ICPDAS_Master_AO8);
   if( VAR_FLAG_IS_WRITE(ICPDAS_Master_AO9) ) iWrite++;
   v_ao[9] = VAR_VALUE(ICPDAS_Master_AO9);
   if( VAR_FLAG_IS_WRITE(ICPDAS_Master_AO10) ) iWrite++;
   v_ao[10] = VAR_VALUE(ICPDAS_Master_AO10);
   if( VAR_FLAG_IS_WRITE(ICPDAS_Master_AO11) ) iWrite++;
   v_ao[11] = VAR_VALUE(ICPDAS_Master_AO11);
   if( VAR_FLAG_IS_WRITE(ICPDAS_Master_AO12) ) iWrite++;
   v_ao[12] = VAR_VALUE(ICPDAS_Master_AO12);
   if( VAR_FLAG_IS_WRITE(ICPDAS_Master_AO13) ) iWrite++;
   v_ao[13] = VAR_VALUE(ICPDAS_Master_AO13);
   if( VAR_FLAG_IS_WRITE(ICPDAS_Master_AO14) ) iWrite++;
   v_ao[14] = VAR_VALUE(ICPDAS_Master_AO14);
   if( VAR_FLAG_IS_WRITE(ICPDAS_Master_AO15) ) iWrite++;
   v_ao[15] = VAR_VALUE(ICPDAS_Master_AO15);
   if ( iWrite )
   {
      gWriteCount++;
      if ( ! MTM_WRITEAO(ICPDAS_Master, 1, 0 - VAR_VALUE(ICPDAS_Master_ADDR_BASE), 16, v_ao, 200) )
          return HMI_ERROR;
   }
}

if (gWriteCount) return HMI_OK;


memset(v_ao, 0, sizeof(v_ao));
if (ICPDAS_Master_ENABLE_AO && ICPDAS_Master_R_ACTION) {
  if (MTM_READAO(ICPDAS_Master, 1, 0 - VAR_VALUE(ICPDAS_Master_ADDR_BASE), 16, v_ao, 200) )
{
	VAR_SET(ICPDAS_Master_AO0, v_ao[0]);
	VAR_SET(ICPDAS_Master_AO1, v_ao[1]);
	VAR_SET(ICPDAS_Master_AO2, v_ao[2]);
	VAR_SET(ICPDAS_Master_AO3, v_ao[3]);
	VAR_SET(ICPDAS_Master_AO4, v_ao[4]);
	VAR_SET(ICPDAS_Master_AO5, v_ao[5]);
	VAR_SET(ICPDAS_Master_AO6, v_ao[6]);
	VAR_SET(ICPDAS_Master_AO7, v_ao[7]);
	VAR_SET(ICPDAS_Master_AO8, v_ao[8]);
	VAR_SET(ICPDAS_Master_AO9, v_ao[9]);
	VAR_SET(ICPDAS_Master_AO10, v_ao[10]);
	VAR_SET(ICPDAS_Master_AO11, v_ao[11]);
	VAR_SET(ICPDAS_Master_AO12, v_ao[12]);
	VAR_SET(ICPDAS_Master_AO13, v_ao[13]);
	VAR_SET(ICPDAS_Master_AO14, v_ao[14]);
	VAR_SET(ICPDAS_Master_AO15, v_ao[15]);
} else 
    return HMI_ERROR;
}
END_FUNCTION_BLOCK();

     return HMI_OK;
  }
  return HMI_ERROR;
}





static void DoReconnection_TCPIP_1() {
  switch(hmi_TCPState(TCPIP_1)){
  case STATE_TCP_IDLE:
  TCPIP_1 = -1;
  ICPDAS_Master.Handle=-1;
  if ( ICPDAS_Master_ENABLE_DEVICE ) {
    if (0 == TCPIP_1_RI) {
      TCPIP_1_RI = g_ulTickTmrEvtTrig;
    } else if (TCPIP_1_RI > 0) {
      if ((MAGIC_NUM_TO_CON == TCPIP_1_RI) || (g_ulTickTmrEvtTrig - TCPIP_1_RI > (5000 / 10))) {
        MODBUS_REGISTER_TCP(TCPIP_1, TCP_IPADDR(10,0,8,130), 502);
        MODBUS_REGISTER_BY_HANDLE(ICPDAS_Master, TCPIP_1, 1);
        MODBUS_WAIT(ICPDAS_Master);
        TCPIP_1_RI = 0;
      }
    }
  } else {
    TCPIP_1_RI = MAGIC_NUM_TO_CON;
  } break;
  
  case STATE_TCP_LISTEN:
  break;
  
  default:
  case STATE_TCP_CONNECTING:
  if ( ICPDAS_Master_ENABLE_DEVICE ) {
  ; } else {
    hmi_TCPAbandon(TCPIP_1, 1);
    TCPIP_1 = -1;
  ICPDAS_Master.Handle=-1;
    TCPIP_1_RI = MAGIC_NUM_TO_CON;
  } break;
  
  case STATE_TCP_CONNECTED:
  if ( ICPDAS_Master_ENABLE_DEVICE ) {
  TCPIP_1_RI = 0; } else {
    mtm_Unregister(TCPIP_1);
    TCPIP_1 = -1;
  ICPDAS_Master.Handle=-1;
    TCPIP_1_RI = MAGIC_NUM_TO_CON;
  } break;
  } // end of switch
}


BYTE hmi_MtmReconnectState(BYTE err, tModbusTCPDevice* mtmdev)
{
  mtmdev->preerrsta = mtmdev->errsta;
  switch (hmi_TCPState(mtmdev->Handle))
  {
  default:
  case STATE_TCP_IDLE:
  case STATE_TCP_LISTEN:
    mtmdev->errsta = 1;
    break;
  case STATE_TCP_CONNECTING:
    if(g_ulTickTmrEvtTrig%(500/10) == 0){
      if (mtmdev->preerrsta == 2)
        mtmdev->errsta = 3;
      else if (mtmdev->preerrsta == 3)
        mtmdev->errsta = 2;
      else 
      {
        mtmdev->errsta = 2;
        mtmdev->preerrsta = 2;
      }
    } break;
  case STATE_TCP_CONNECTED:
    if (err > 0) mtmdev->errsta = 1;
    else        mtmdev->errsta = 0;
    
    break;
    }  // switch
  return mtmdev->errsta;
}

void hmi_IOScan_Process(void)
{
  if ( s_hmi_tcp_inited )
  {
    DoReconnection_TCPIP_1();
    if (ICPDAS_Master_flag)
    {
      VAR_SET(ICPDAS_Master_ERROR, hmi_MtmReconnectState(polling_ICPDAS_Master(1), &ICPDAS_Master));
      ICPDAS_Master_flag = false;
    }

  } else {
    VAR_SET(ICPDAS_Master_ERROR, 1);
  }


  default_input(1);
}

void hmi_frame0()
{
  tContext sContext;
  
  RegisterNullWidgetMsgProc(hmi_Ladder_Process);
  
  hmi_grlib_init(HMI_GRLIB_INIT_MULTI);
  GrContextInit(&sContext, HMI_DISPLAY_DRIVER_PTR);
  hmi_GotoFrame(1);
  GrFlush(&sContext);
}
