﻿#include "hmiworks.h"
BYTE ladder_main(BYTE);

int g_hmi_CurrentFrame = 0;
static int s_hmi_tcp_inited = 0;

static const char *g_FrameNames[] = 
{
  "Frame1",
};

const int g_FrameCount = (sizeof(g_FrameNames)/sizeof(char *));

#define MAGIC_NUM_TO_CON		472882027

HANDLE TCPIP_1=-1;
tModbusTCPDevice ICPDAS_Slave={-1};

WORD gmts_AioBuf[16] = {0};

void hmi_CheckModbus()
{
  MODBUS_CHECK_SERVER(ICPDAS_Slave);
}

void _tpd_tcp_initial()
{
  if ( !lwIPLocalIPAddrGet() ) return;

  MODBUS_TCP_SLAVE_LISTEN(TCPIP_1, 502);

  mts_RegisterSlave(1, 0, 0, NULL, 0, 16, gmts_AioBuf);
  hmi_AddHighSpeedCallback((PFN_HSCallback)mts_ProcessCmd, TCPIP_1);
  MODBUS_REGISTER_BY_HANDLE(ICPDAS_Slave, TCPIP_1, 1);
  MODBUS_WAIT(ICPDAS_Slave);

  s_hmi_tcp_inited = 1;
}

volatile unsigned long g_TimerTicksCount = 0;
unsigned long g_ulTickTmrEvtTrig = 0;

static volatile bool ICPDAS_Slave_flag = false;

void hmi_TimerTrigger()
{
  g_TimerTicksCount++;
  
  if ((g_TimerTicksCount%(200/10)) == 0)
  ICPDAS_Slave_flag = true;
  
  if ( g_TimerTicksCount%(100/10) == 0)
  { g_ulTickTmrEvtTrig = g_TimerTicksCount;
    HMI_REQUEST_LADDER_PROCESS();}
  
  if ( s_hmi_tcp_inited ) {
     if ((g_TimerTicksCount%50) == 0) hmi_CheckModbus();
  } else if ( g_TimerTicksCount > 80 )
     _tpd_tcp_initial();
  
  switch(g_hmi_CurrentFrame) {
    case 1: {
     TimerUpdate(&Timer7, 10);
    break;
    }
  }
}

void hmi_FreeCurrentFrame()
{
  switch (g_hmi_CurrentFrame)
  {
	case 1: hmi_FreeFrameWidgets1(); break;
  }
}

void hmi_GetActiveFrame(char* str, unsigned int len)
{
  int FNLen = strlen(g_FrameNames[g_hmi_CurrentFrame-1]) +1;
  if(len >= FNLen)
    memcpy(str, g_FrameNames[g_hmi_CurrentFrame-1], FNLen);
}

const char* hmi_GetCurrentFrameName()
{ return g_FrameNames[g_hmi_CurrentFrame-1];}

extern int hmi_frame_number_to_go;
void hmi_GotoFrameAction(int nFrame)
{
  switch(nFrame)
  {
	case 1: hmi_Frame1(); break;
  }

  WidgetMessageQueueClear();
  HMI_REDRAW();
}

void hmi_GotoFrame(int nFrame)
{
  hmi_frame_number_to_go = nFrame;
}

int hmi_IndexOfFrame(const char *frame_name)
{
  for (int i=0; i<g_FrameCount; i++)
    if (strcmp(frame_name, g_FrameNames[i]) == 0) return i+1;
  return 0;
}

void hmi_GotoFrameByName(const char *frame_name)
{
  hmi_frame_number_to_go = hmi_IndexOfFrame(frame_name);
}

long hmi_Ladder_Process(tWidget *pWidget, unsigned long ulMessage,
                     unsigned long ulParam1, unsigned long ulParam2)

{
  ladder_main(1);
  passDataThruBindingOnChange();
  default_output(1);
  return 1;
}

BYTE polling_ICPDAS_Slave(BYTE en)
{
  if ( ! ICPDAS_Slave_ENABLE_DEVICE ) return 0;
  if (MODBUS_CONNECTED(ICPDAS_Slave)) {
BEGIN_FUNCTION_BLOCK();

DWORD st = mts_GetIOStatus(1);

if(VAR_VALUE(ICPDAS_Slave_ENABLE_AIO) && ICPDAS_Slave_W_ACTION)
{
   // Update to gmts_AIOBuf only when the I/O Tag's write-flag is true.
   // The grms_AIOBuf is global data buffer for the Modbus RTU slave functions 
   // working in ladder mode.
   
   // AIO0 is usually used as device status.
   // When reboot, all I/O tags are initialized as zeros.
   // Client (Modbus RTU master) can then initial the TouchPAD again, 
   // and then set AIO0 to 1 that indicates initialized by client.
   
   VAR_UPDATE_AIO_BUF(&gmts_AioBuf[0],  ICPDAS_Slave_AIO0);
   VAR_UPDATE_AIO_BUF(&gmts_AioBuf[1],  ICPDAS_Slave_AIO1);
   VAR_UPDATE_AIO_BUF(&gmts_AioBuf[2],  ICPDAS_Slave_AIO2);
   VAR_UPDATE_AIO_BUF(&gmts_AioBuf[3],  ICPDAS_Slave_AIO3);
   VAR_UPDATE_AIO_BUF(&gmts_AioBuf[4],  ICPDAS_Slave_AIO4);
   VAR_UPDATE_AIO_BUF(&gmts_AioBuf[5],  ICPDAS_Slave_AIO5);
   VAR_UPDATE_AIO_BUF(&gmts_AioBuf[6],  ICPDAS_Slave_AIO6);
   VAR_UPDATE_AIO_BUF(&gmts_AioBuf[7],  ICPDAS_Slave_AIO7);

   VAR_UPDATE_AIO_BUF(&gmts_AioBuf[8],  ICPDAS_Slave_AIO8);
   VAR_UPDATE_AIO_BUF(&gmts_AioBuf[9],  ICPDAS_Slave_AIO9);
   VAR_UPDATE_AIO_BUF(&gmts_AioBuf[10], ICPDAS_Slave_AIO10);
   VAR_UPDATE_AIO_BUF(&gmts_AioBuf[11], ICPDAS_Slave_AIO11);
   VAR_UPDATE_AIO_BUF(&gmts_AioBuf[12], ICPDAS_Slave_AIO12);
   VAR_UPDATE_AIO_BUF(&gmts_AioBuf[13], ICPDAS_Slave_AIO13);
   VAR_UPDATE_AIO_BUF(&gmts_AioBuf[14], ICPDAS_Slave_AIO14);
   VAR_UPDATE_AIO_BUF(&gmts_AioBuf[15], ICPDAS_Slave_AIO15);
}

if(VAR_VALUE(ICPDAS_Slave_ENABLE_AIO) && ICPDAS_Slave_R_ACTION)
{
   // Update all I/O Tags from the gmts_AioBuf.

   if ( st & 2 ) // bit 1 is dity flag for AIO
   {
      VAR_SET(ICPDAS_Slave_AIO0,  gmts_AioBuf[0]);
      VAR_SET(ICPDAS_Slave_AIO1,  gmts_AioBuf[1]);
      VAR_SET(ICPDAS_Slave_AIO2,  gmts_AioBuf[2]);
      VAR_SET(ICPDAS_Slave_AIO3,  gmts_AioBuf[3]);
      VAR_SET(ICPDAS_Slave_AIO4,  gmts_AioBuf[4]);
      VAR_SET(ICPDAS_Slave_AIO5,  gmts_AioBuf[5]);
      VAR_SET(ICPDAS_Slave_AIO6,  gmts_AioBuf[6]);
      VAR_SET(ICPDAS_Slave_AIO7,  gmts_AioBuf[7]);
   
      VAR_SET(ICPDAS_Slave_AIO8,  gmts_AioBuf[8]);
      VAR_SET(ICPDAS_Slave_AIO9,  gmts_AioBuf[9]);
      VAR_SET(ICPDAS_Slave_AIO10, gmts_AioBuf[10]);
      VAR_SET(ICPDAS_Slave_AIO11, gmts_AioBuf[11]);
      VAR_SET(ICPDAS_Slave_AIO12, gmts_AioBuf[12]);
      VAR_SET(ICPDAS_Slave_AIO13, gmts_AioBuf[13]);
      VAR_SET(ICPDAS_Slave_AIO14, gmts_AioBuf[14]);
      VAR_SET(ICPDAS_Slave_AIO15, gmts_AioBuf[15]);
   }
}

END_FUNCTION_BLOCK();

     return HMI_OK;
  }
  return HMI_ERROR;
}





BYTE hmi_MtmReconnectState(BYTE err, tModbusTCPDevice* mtmdev)
{
  mtmdev->preerrsta = mtmdev->errsta;
  switch (hmi_TCPState(mtmdev->Handle))
  {
  default:
  case STATE_TCP_IDLE:
  case STATE_TCP_LISTEN:
    mtmdev->errsta = 1;
    break;
  case STATE_TCP_CONNECTING:
    if(g_ulTickTmrEvtTrig%(500/10) == 0){
      if (mtmdev->preerrsta == 2)
        mtmdev->errsta = 3;
      else if (mtmdev->preerrsta == 3)
        mtmdev->errsta = 2;
      else 
      {
        mtmdev->errsta = 2;
        mtmdev->preerrsta = 2;
      }
    } break;
  case STATE_TCP_CONNECTED:
    if (err > 0) mtmdev->errsta = 1;
    else        mtmdev->errsta = 0;
    
    break;
    }  // switch
  return mtmdev->errsta;
}

void hmi_IOScan_Process(void)
{
  if ( s_hmi_tcp_inited )
  {
    VAR_SET(ICPDAS_Slave_ERROR, polling_ICPDAS_Slave(1)? 1:0);
  } else {
    VAR_SET(ICPDAS_Slave_ERROR, 1);
  }


  default_input(1);
}

void hmi_frame0()
{
  tContext sContext;
  
  RegisterNullWidgetMsgProc(hmi_Ladder_Process);
  
  hmi_grlib_init(HMI_GRLIB_INIT_MULTI);
  GrContextInit(&sContext, HMI_DISPLAY_DRIVER_PTR);
  hmi_GotoFrame(1);
  GrFlush(&sContext);
}
